package at.ac.uibk.gitsearch.service.dto;

import at.ac.uibk.gitsearch.config.ApplicationProperties;

public class FragmentDTO {

    private String fragment;
    private int firstLineNumber;

    public FragmentDTO() {
        this.firstLineNumber = 1;
    }

    public FragmentDTO matchFillLine(String content, String fragment, ApplicationProperties.Search search) {
        String fragmentWOHighlight = fragment
            .replaceAll(search.getHighlightPre(), "")
            .replaceAll(search.getHighlightPost(), "");

        int idx = content.indexOf(fragmentWOHighlight);
        int idxEnd = idx + fragmentWOHighlight.length();

        int firstNewline = 0;

        int nextNewline = content.indexOf('\n');
        while (nextNewline != -1 && nextNewline < idx) {
            ++firstLineNumber;
            firstNewline = nextNewline + 1;
            nextNewline = content.indexOf('\n', nextNewline + 1);
        }

        int lastNewline = content.indexOf('\n', idxEnd);
        if (lastNewline == -1) {
            lastNewline = content.length();
        }

        StringBuilder result = new StringBuilder();
        if (firstNewline != idx) {
            result.append(content, firstNewline, idx);
        }
        result.append(fragment);
        if (lastNewline != idxEnd) {
            result.append(content, idxEnd, lastNewline);
        }
        this.fragment = result.toString();
        return this;
    }

    public String getFragment() {
        return fragment;
    }

    public void setFragment(String fragment) {
        this.fragment = fragment;
    }

    public int getFirstLineNumber() {
        return firstLineNumber;
    }

    public void setFirstLineNumber(int firstLineNumber) {
        this.firstLineNumber = firstLineNumber;
    }
}
